#ifndef __LAUNCHER_CLOCK_H__
#define __LAUNCHER_CLOCK_H__


#include <qtimer.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qpopupmenu.h>
#include <qdatetime.h>
#include <qcopchannel_qws.h>

class KeybShow : public QLabel
{
    Q_OBJECT
public:
    KeybShow( QWidget *parent );

public slots:
  void message( const QCString& );

protected:
    void mousePressEvent( QMouseEvent * );
    void mouseReleaseEvent( QMouseEvent * );
    int lang;
	int prevLang;
	QColor defaultBackgroundColor;
	
protected slots:
	void displayLayouts();
	void menuItemClicked(int);
	
private:
    QCopChannel* _chanel;
    int maps[10];
    int nmaps;
	int numLayouts;
	bool adaptiveSwitch;
	
    void load_config();
    bool checkMap(QString fname, QString& n);
	void nextLayout();
	QPixmap loadFlag(const QString& label);
	void setLabel(int lang);
	
	QPopupMenu*  m_pMenu;
	QTimer* m_pTimer;
	bool mButtonDown;
};


#endif // __LAUNCHER_CLOCK_H__
