#include <stdio.h>
#include "keyboardhandler.h"
//#include "xmlparser.h"
#include <qpe/global.h>
#include <qlabel.h>
#include <qtextstream.h>
#include <qfile.h>
#include <qpe/config.h>

#include <qnamespace.h>
#include <qpe/qcopenvelope_qws.h>
#include "../config.h"

#include "loadkmaps.h"

KeyboardHandler::KeyboardHandler( QObject* parent, const char* name ) : QObject( parent, name ), _input(0),
flagFn(false), meta_on(0), layoutSwitch(0)
{
  reread();
  _time.start();
}

bool KeyboardHandler::filter(int uu/*unicode*/, int keycode, int modifiers, 
                             bool isPress, bool autoRepeat) 
{
  if ( !_active )
    return false;
	
  bool handled = false;
  ushort unicode = 0;
  if ( isPress ) {

    if (keycode == Qt::Key_Meta) {
	if (meta_on) meta_on = 0;
	else meta_on = isPress;
	return false;
    }

    if (meta_on) meta_on = 0;

/////////////////////////
//{    
//    FILE *of=fopen("/tmp/kbc.txt","a");
//    fprintf(of, "%02X, %02X, %04X, %04X\n", flagFn, modifiers, keycode, uu);
//    fclose(of);
//}    
/////////////////////////

#if (SLC700 == 1)
    // check for EURO
    if (flagFn && (keycode == 0x201b)) {
        emit key( 0x20ac, 0, 0, true, false );
        emit key( 0x20ac, 0, 0, false, false );
		_time.restart();
		return true;
    }

    //check for SHIFT
    if (flagFn && (keycode == 0x1020)) {
#ifndef KBD_DEMO
	layoutSwitch = 1;
#endif
    } else {
	if (layoutSwitch) layoutSwitch = 0;
    }
#endif

    if (keycode == 4165) {
      flagFn = true;
	  return false;
    } 
    
//    if (nlayout > 0) {
      bool match = false;
      if (flagFn) {
        for (int i = 0; hkeymap_fn[i].keycode != 0; i++) {
	    if (keycode == hkeymap_fn[i].keycode) {
		unicode = (modifiers&8 || modifiers&16)?hkeymap_fn[i].unicode:hkeymap_fn[i].bunicode;
		match = true;
		break;
	    }
	}
      } else {
	for (int i = 0; hkeymap[i].keycode != 0; i++) {
	    if (keycode == hkeymap[i].keycode) {
		unicode = (modifiers&8)?hkeymap[i].unicode:hkeymap[i].bunicode;
		match = true;
		break;
	    }
	}
      }

      if ( match ) {
            emit key( /*replacement[i].unicode()*/unicode, 0, 0, true, false );
            emit key( /*replacement[i].unicode()*/unicode, 0, 0, false, false );
          handled = true; // Dont insert this characters
      }
//    }
    _time.restart();
  } else {
    if (keycode == 4165) {
        flagFn = false;
	if (layoutSwitch) {
	    QCopEnvelope* env = new QCopEnvelope( "CyrInput/Private", "nextKbdLayout()");
	    delete env;
	    layoutSwitch = 0;
	}
    }
  }
  
  if (!handled)
     return KeyHelper::filter(uu /* unicode */, keycode, modifiers, isPress, autoRepeat);

  return handled;
}

void KeyboardHandler::message( const QCString& message )
{
}

void KeyboardHandler::reread()
{
  _active = true;
  _delay = 1000;
}
