#include <stdio.h>
#include <string.h>

#include "loadkmaps.h"

kbdecode hkeymap[64];
kbdecode hkeymap_fn[64];
unsigned short keymap[50];
unsigned short keymap_shift[50];

static char *getCode(char *ptr, unsigned short *in)
{
    while ((strlen(ptr) > 0) && (*ptr <= ' ')) ptr++;
    if (*ptr == '\'') {
	ptr++;
	*in = *ptr;
	ptr+=2;
    } else {
	unsigned short n = 0;
	if (*(ptr + 1) == 'x') ptr += 2;
	while (*ptr > ' ') {
	    if ((*ptr >= 'a') && (*ptr <= 'f')) {
		n = (n << 4) + (*ptr - 'a' + 10);
	    } else if ((*ptr >= 'A') && (*ptr <= 'F')) {
		n = (n << 4) + (*ptr - 'a' + 10);
	    } else if ((*ptr >= '0') && (*ptr <= '9')) {
		n = (n << 4) + (*ptr - '0');
	    } else n = n << 4;
	    ptr++;
	}
	*in = n;
    }
    return ptr;
}

void loadKmap(char *name)
{
    int fEnd = 0;
    int count = 0;
    char str[128];

    FILE *inf = fopen(name, "r");
    if (!inf) return;
    while ((!fEnd) && (!feof(inf)) ) {
	fgets(str, 128, inf);
	while ((strlen(str) > 0) && (str[strlen(str)-1] < ' ')) str[strlen(str)-1] = 0;
	if (strcmp(str, "[screen]")==0) {
	    int fEnd = 1;
	    count = 0;
	    while (fEnd) {
		fgets(str, 128, inf);
		while ((strlen(str) > 0) && (str[strlen(str)-1] < ' ')) str[strlen(str)-1] = 0;
		char *ptr = str;
		while ((strlen(ptr) > 0) && (*ptr <= ' ')) ptr++;
		if ((strlen(ptr) > 0) && (*ptr != '#')) {
		    ptr = getCode(ptr, &keymap[count]);
		    ptr = getCode(ptr, &keymap_shift[count]);
		    //printf("%x\t%x\n", keymap[count], keymap_shift[count]);
		    fEnd = keymap[count] | keymap_shift[count];
	    	    count++;
		}
	    }
	    //printf("count = %d\n", count);
	} else if (strcmp(str, "[keyboard]")==0) {
	    int fEnd = 1;
	    count = 0;
	    while (fEnd) {
		fgets(str, 128, inf);
		while ((strlen(str) > 0) && (str[strlen(str)-1] < ' ')) str[strlen(str)-1] = 0;
		char *ptr = str;
		while ((strlen(ptr) > 0) && (*ptr <= ' ')) ptr++;
		if ((strlen(ptr) > 0) && (*ptr != '#')) {
		    ptr = getCode(ptr, &hkeymap[count].keycode);
		    ptr = getCode(ptr, &hkeymap[count].unicode);
		    ptr = getCode(ptr, &hkeymap[count].bunicode);
		    //printf("%x\t%x\t%x\n", hkeymap[count].keycode, hkeymap[count].unicode, hkeymap[count].bunicode);
		    fEnd = hkeymap[count].keycode | hkeymap[count].unicode | hkeymap[count].bunicode;
	    	    count++;
		}
	    }
	    //printf("count = %d\n", count);
	} else if (strcmp(str, "[keyboard-fn]")==0) {
	    int fEnd = 1;
	    count = 0;
	    while (fEnd) {
		fgets(str, 128, inf);
		while ((strlen(str) > 0) && (str[strlen(str)-1] < ' ')) str[strlen(str)-1] = 0;
		char *ptr = str;
		while ((strlen(ptr) > 0) && (*ptr <= ' ')) ptr++;
		if ((strlen(ptr) > 0) && (*ptr != '#')) {
		    ptr = getCode(ptr, &hkeymap_fn[count].keycode);
		    ptr = getCode(ptr, &hkeymap_fn[count].unicode);
		    ptr = getCode(ptr, &hkeymap_fn[count].bunicode);
		    //printf("%x\t%x\t%x\n", hkeymap_fn[count].keycode, hkeymap_fn[count].unicode, hkeymap_fn[count].bunicode);
		    fEnd = hkeymap_fn[count].keycode | hkeymap_fn[count].unicode | hkeymap_fn[count].bunicode;
	    	    count++;
		}
	    }
	    //printf("count = %d\n", count);
	}
    }	
    fclose(inf);
}
